/* Alternate yet similar approach */

%{
	FILE *fpin,*fpout;
	#define comment 100
	#define nocomment 200	
	int ncl=0,state=nocomment,lcf=0;
%}

%option yylineno		
/* ^ Enable option to keep track of line numbers.*/

%%
"/*"	{
		state=comment;	
		if(lcf!=yylineno)	
		/*If the previous comment and this comment are on the same line, ignore. */			
		{			/* Otherwise increment ncl*/
					ncl++;
					lcf=yylineno;	
					/*lcf = line on which Last Comment was Found*/
		}
	}
\n	{
		if(state==comment)
			ncl++;		/*One comment spanning multiple lines*/
		else 
			fprintf(fpout,"%s",yytext);
	}

"*/"			{
				state=nocomment;	/*Nested comments are not allowed.*/
			}


.|\n			{
				if(state!=comment) 
					fprintf(fpout,"%s",yytext);	/*Print all noncommented text into fpout*/
			}
%%


int main(int argc, char *argv[])
{
	if(argc < 3)
	{
		printf("Usage: %s infile outfile\n",argv[0]);
		return 1;
	}	
	fpin=fopen(argv[1],"r");
	fpout=fopen(argv[2],"w");
	if(!fpin || !fpout)
		return 0;
	yyin=fpin;
	yylex();
	fclose(fpin);
	fclose(fpout);
	printf("\n Comment Lines =%d\n",ncl);
}
